scr = $0400
spr= scr+$3f8
vic= $d000
col= $d800
chr= scr; where character set matrix! is stored

; notes for star positioning
; minimum x: #32 (d010 0) max x: #56 (d010 set) range of #280 (or #140) div by 2 due to double pixels
; minimum y: #49 max #117 resp #162/230-> 2x range of #68

*= $0400
	!bin "fontscr.prg",,2
endoffontscr
	!fill $0630-endoffontscr,$ce
*= $0630
font
	!bin "autopsyfont3x3sharplight-font.bin"
overflowtab
	!byte $00,$00
pointerstat
	!byte 3,7,11,15,19,23,27,31
	!byte 3,7,11,15,19,23,27,31	

*= $0801                                                    
	!byte $0b,$08,$e1,$07,$9e,$33,$37,$37,$36,0;,0;,0  
*= $080b
start
	lda #$00
-	sta init-1,x; clear empty sprite
	sta init+76-1,x
	dex
	bne -
	jsr $1000
	lda #$20
	sta init+64+31; build almost empty

loop

	ldx #16
-	lda postab-1,x
	sta vic-1,x
	dex
	bne -
	lda overflowtab
	sta $d010	

rasterpointer
	lda #$00
	and #%00011111
	tay
	lda #$02
	sta turns+1

	ldx #$88
	cpx $d012
	bne *-3
scrollval
	lda #$d0; multi color
	sta $d016; 38 columns
	inx
	cpx $d012
	bne *-3

	lda #$f3
	sta $d022; mc1
	lda #$f6
	sta $d023; mc2

	inx
split	
	cpx $d012
	bne *-3
-	dec rastercounter+1
	inx; #$8b
	cpx $d012
	bne *-3
	lda rastercoltab,y
	sta $d021	
	iny
rastercounter; 7 good lines
	lda #07
	bne -
	jsr waste12cycles
	lda #$07
	sta rastercounter+1
	lda #$06
	sta rastercounter2+1
	dec turns+1
	lda rastercoltab,y
	inx
	iny	
	sta $d021
turns
	lda #$00
	bne split+5
	cpx $d012
	bne *-3
-	dec rastercounter2+1
	inx
	cpx $d012
	bne *-3
	lda rastercoltab,y
	sta $d021	
	iny
rastercounter2; 7 good lines
	lda #07
	bne -
	inx
	cpx $d012
	bne *-3
	sta $d021
	dec rasterpointer+1

	lda #$f0
	sta $d022; mc1
;	lda #$f0
	sta $d023; mc2

	
; update star sprites
	ldx #16
-	lda postab+16-1,x
	sta vic-1,x
	dex
	bne -
	lda overflowtab+1
	sta $d010	
	lda #$fc
	cmp $d012
	bne *-3
	ldx #16
-	lda #$00
	inc pointerstat-1,x
	lda pointerstat-1,x
	and #%00011111
	sta pointerstat-1,x
	dex
	bne -
setspritestat
	ldx #$00
-	lda pointerstat,x
	tay
	lda pointertab,y
	sta spr,x
	tya
	bne +
	txa 
	pha
	jsr xpos
	stx newxposval+1;goes into vic
	sta newyposval+1;goes into vic+1
	pla
	pha
	jsr computed010
screenhalf	
	sta overflowtab;$d010
	pla
	pha
	asl
	tax
newxposval
	lda #$00
	sta postab,x
	inx
newyposval	
	lda #$00
	sta postab,x
	pla
	tax	
+	inx
	cpx #08
	bne + 
	inc screenhalf+1
	inc d010computingval1+1
	inc d010computingval2+1
	lda #162
	sta ypos+1
+	cpx #16
	bne -
	dec screenhalf+1	
	dec d010computingval1+1
	dec d010computingval2+1	
	lda #49
	sta ypos+1	

; compute scroll	
	lda scrollval+1
	and #%00000111;#$07	
	sec 
scrollspeed 	
	sbc #%00000100; should be even no. due to multicolor double pixels
	and #%00000111;#$07
	ora #$d0; multicolor mode
	sta scrollval+1
	bcc newtiles
	jmp nonewtile
newtiles
tilecounter
	lda #$00
	bne nonewchar
textpointer
	lda text
	cmp #$ff
	bne +
	lda #<text
	sta textpointer+1
	lda #>text
	sta textpointer+2
	bne textpointer
+	and #%00111111
	pha
	asl
	tax
	lda charpostab,x; lowbyte
	sta source0+1
	inx
	lda charpostab,x; hibyte
	sta source0+2
	pla
	tax
	lda charwidthtab,x
	sta tilecounter+1
	inc textpointer+1
	bne +
	inc textpointer+2
+	bne source0 ; saves 1 byte 1 cycle compared to JMP
nonewchar
	inc source0+1
	bne +
	inc source0+2
+	
source0
	lda scr
	sta scr+(11*40)+39
	lda source0+2
	sta source1+2
	lda source0+1
	clc
	adc #40
	sta source1+1
	bcc source1
	inc source1+2
source1	
	lda scr+40
	sta scr+(12*40)+39
	lda source1+2
	sta source2+2
	lda source1+1
	clc
	adc #40
	sta source2+1
	bcc source2
	inc source2+2
source2
	lda scr+80
	sta scr+(13*40)+39	
	ldx #00
-	lda scr+(11*40)+1,x
	sta scr+11*40,x
	lda scr+(12*40)+1,x
	sta scr+12*40,x
	lda scr+(13*40)+1,x
	sta scr+13*40,x
	inx
	cpx #39
	bne -
	dec tilecounter+1
	
nonewtile	
	
-	lda $dc01
	cmp #239
	bne +
	lda #$00
	sta $d011
	sta $d418
	jmp $fce2
+	jsr $1003

	jmp loop	



	
*= $0a00; dez 2752
init; stuff later overwritten for (empty) sprites	
	sei
	lda #$10
	sta $d018
	ldx #$0b; $908 has got opcode $40 RTI; bend NMI vector
	stx $318
	stx $fffa
	ldx #$09 ; Hi Byte $0908
	stx $0319
	stx $fffb	
	lda #$d0
	sta $d016
	lda #$f0
	sta $d022; mc1
	sta $d023; mc2

setupsprites
	ldx #$08
-	lda #$04
	sta vic+39-1,x
	dex
	lda #$06
	sta vic+39-1,x
	dex
	bne -
	stx vic+$21
	stx vic+$20; later $20
	dex
;	lda #$ff
	stx $d015; all on
	stx vic+28; all mc
	txa
	ldx #16
-	sta vic-1,x
	dex
	bne -
-	lda #$f8
	sta col-1,x
	sta col-1+$100,x
	sta col-1+$200,x
	sta col-1+$2e8,x
	dex
	bne -
;	txa
	inx
	stx vic+37; spr mc 1
	ldx #$03
	stx vic+38; spr mc 2

palcheck
	ldy #$00
checkstart
	iny
lp4:
    LDA $D011
    BMI lp4
lp5:
    LDA $D011
    BPL lp5
lp6:
    LDA $D012
    CMP #$20
    BEQ skp4
    LDA $D011
    BMI lp6
    CLC 		; C=0 - ntsc
skp4:
	cmp #$1b
	bne resultPAL
	cpy #$20; 32 tries without any change --> set NTSC
	bne checkstart

resultNTSC; leave NTSC patch
	lda #$ad; replace opcode DEC by LDA# to disable tune-internal routine to pitch up music
	sta $120b
resultPAL; 
	lda #$1a 
	sta $d011
	ldx #76
	jmp start

	
*= $0a98;0b40
sprite
	!bin "star6.spd",192-24,128+3+24

*= $0b40
postab
	!byte $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff; upper screen
	!byte $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff; lower screen
rastercoltab
	!byte $0c,$0c,$0f,$0f,$01,$01,$0f,$0f,$0c,$0c,$0b,$0b,$00,$00,$06,$06
	!byte $04,$0e,$03,$03,$01,$01,$03,$03,$0e,$04,$06,$06,$00,$00,$00,$00
	!byte $0c,$0c,$0f,$0f,$01,$01,$0f,$0f,$0c,$0c,$0b,$0b,$00,$00,$06,$06
	!byte $04,$0e,$03,$03,$01,$01,$03,$03,$0e,$04,$06,$06,$00,$00,$00,$00
charpostab
	!byte <chr+(2*120)+30,>chr+(2*120)+30; @-> special: 10 tiles wide space
	!byte <chr+(0*120)+(0*3),>chr+(0*120)+(0*3); a
	!byte <chr+(0*120)+(1*3),>chr+(0*120)+(1*3); b
	!byte <chr+(0*120)+(2*3),>chr+(0*120)+(2*3); c
	!byte <chr+(0*120)+(3*3),>chr+(0*120)+(3*3); d
	!byte <chr+(0*120)+(4*3),>chr+(0*120)+(4*3); e
	!byte <chr+(0*120)+(5*3),>chr+(0*120)+(5*3); f
	!byte <chr+(0*120)+(6*3),>chr+(0*120)+(6*3); g
	!byte <chr+(0*120)+(7*3),>chr+(0*120)+(7*3); h
	!byte <chr+(0*120)+(8*3),>chr+(0*120)+(8*3); i
	!byte <chr+(0*120)+(8*3)+1,>chr+(0*120)+(8*3)+1; j
	!byte <chr+(0*120)+(9*3)+1,>chr+(0*120)+(9*3)+1; k
	!byte <chr+(0*120)+(10*3)+1,>chr+(0*120)+(10*3)+1; l
	!byte <chr+(0*120)+(11*3)+1,>chr+(0*120)+(11*3)+1; m
	!byte <chr+(1*120)+(0*3),>chr+(1*120)+(0*3); n
	!byte <chr+(1*120)+(1*3),>chr+(1*120)+(1*3); o
	!byte <chr+(1*120)+(2*3),>chr+(1*120)+(2*3); p
	!byte <chr+(1*120)+(3*3),>chr+(1*120)+(3*3); q
	!byte <chr+(1*120)+(4*3),>chr+(1*120)+(4*3); r
	!byte <chr+(1*120)+(5*3),>chr+(1*120)+(5*3); s
	!byte <chr+(1*120)+(6*3),>chr+(1*120)+(6*3); t
	!byte <chr+(1*120)+(7*3),>chr+(1*120)+(7*3); u
	!byte <chr+(1*120)+(8*3),>chr+(1*120)+(6*3); v
	!byte <chr+(1*120)+(9*3),>chr+(1*120)+(7*3); w
	!byte <chr+(1*120)+(10*3)+1,>chr+(1*120)+(10*3)+1; x
	!byte <chr+(1*120)+(11*3)+1,>chr+(1*120)+(11*3)+1; y
	!byte <chr+(1*120)+(12*3)+1,>chr+(1*120)+(12*3)+1; z
	!byte <chr+(2*120)+27,>chr+(2*120)+27; [ -> -
	!byte <chr+(2*120)+27+80,>chr+(2*120)+27+80; Pound Char -> special: short SPC (only 1 tile)
	!byte <chr+(2*120)+27,>chr+(2*120)+27; ] -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; arrow up -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; arrow lft -> -	
	!byte <chr+(2*120)+27+80,>chr+(2*120)+27+80; SPC
	!byte <chr+(2*120)+(5*3),>chr+(2*120)+(5*3); !
	!byte <chr+(2*120)+(5*3)+80,>chr+(2*120)+(5*3)+80; "
	!byte <chr+(2*120)+24,>chr+(2*120)+24; # -> star ani 1 not implemented yet
	!byte <chr+(2*120)+24,>chr+(2*120)+24; $ -> star ani 2 not implemented yet	
	!byte <chr+(2*120)+24,>chr+(2*120)+24; % -> star ani 3 not implemented yet
	!byte <chr+(2*120)+24,>chr+(2*120)+24; & -> star ani 4 not implemented yet	
	!byte <chr+(2*120)+(5*3)+80+2,>chr+(2*120)+(5*3)+80+2; '
	!byte <chr+(2*120)+27,>chr+(2*120)+27; ( -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; ) -> -	
	!byte <chr+(2*120)+24,>chr+(2*120)+24; * -> plane char for effect not implemented yet
	!byte <chr+(2*120)+(7*3),>chr+(2*120)+(7*3); +
	!byte <chr+(2*120)+(5*3)+2,>chr+(2*120)+(5*3)+2; ,
	!byte <chr+(2*120)+27,>chr+(2*120)+27; -	
	!byte <chr+(2*120)+(5*3)+1,>chr+(2*120)+(5*3)+1; .	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; / -> -	
	!byte <chr+(1*120)+(1*3),>chr+(1*120)+(1*3); 0 -> o
	!byte <chr+(0*120)+(8*3),>chr+(0*120)+(8*3); 1 -> i
	!byte <chr+(1*120)+(12*3)+1,>chr+(1*120)+(12*3)+1; z
	!byte <chr+(2*120)+(0*3),>chr+(2*120)+(0*3); 3
	!byte <chr+(2*120)+(1*3),>chr+(2*120)+(1*3); 4
	!byte <chr+(1*120)+(5*3),>chr+(1*120)+(5*3); 5 -> s
	!byte <chr+(2*120)+(2*3),>chr+(2*120)+(2*3); 6
	!byte <chr+(2*120)+(3*3),>chr+(2*120)+(3*3); 7
	!byte <chr+(2*120)+(4*3),>chr+(2*120)+(4*3); 8
	!byte <chr+(0*120)+(6*3),>chr+(0*120)+(6*3); 9 -> g
	!byte <chr+(2*120)+27,>chr+(2*120)+27; : -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; ; -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; < -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; = -> -	
	!byte <chr+(2*120)+27,>chr+(2*120)+27; > -> -	
	!byte <chr+(2*120)+(6*3),>chr+(2*120)+(6*3); ?
		
charwidthtab	
	!byte 10; extra wide space 10 tiles
	!fill 8,3; A-H
	!byte 1; i
	!byte 3,3,3; jkl
	!byte 4; M
	!fill 9,3; n-v
	!byte 4; w
	!byte 3,3,3,3,1,3,3,3,3; 	!fill 9,3; x-SPC 
	!byte 1,2,3,3,3,3; !"#$%&
	!byte 1,3,3,3,3,1,3,1,3,3,1; '()*+,-./01
	!fill 14,3

*= $0c60; 928 bytes for scrolltext

text
	!ct scr
;	!byte 00
;	!byte 01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29
;	!byte 30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59
;	!byte 60,61,62,63,64;05,06,07,08,09,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29
	!tx "@@@@"; means one empty scroll line of 40 SPCes
	!tx "-*+ the",28
	!tx "ryk of mayday! in 2019 +*-"
	!tx "@@@@"; means one empty scroll line of 40 SPCes
	!tx "brings u... ",34
	!tx "zoolook msk stars intro remeistered",34,28,"!"
	!tx "@@@@"; means one empty scroll line of 40 SPCes
	!tx "a tribute to meistersoft cologne's intro packer intro but also to jean michel jarre + rob hubbard."
	!tx "@@@@"; means one empty scroll line of 40 SPCes
	!tx "that old intro featured 8 sprites, a 2x2 scroll with cool metal rasters + rob hubbard's zoolook music."
	!tx "@@@@"; means one empty scroll line of 40 SPCes
	!tx "just in case you don't recall that old thing, it was one of the most raped intros ever, you find it with stars or the heart sprites from game mikie."
	!tx "@@@@"
	!tx "i pixeled a 3x3 font + new stars,"
	!tx " then coded this intro from scratch + optimized few things, e.g. doubled stars amount"
	!tx " by multiplexing."
	!tx " i also hacked + remixed hubbard's tune + added some cowbell + drive + fitted everything"
	!tx " into 4",28,"kb incl. 1",28,"kb reserved for scrolltext."
	!tx "@@@@"
	!tx "i deliberately didn't use any logos, hoping it may be ripped and used by others as often as the original, hehe..."
	!tx "@@@@"
	!tx "running out of ram, so greetings to all c-64 maniax in the world!"
	!tx "@@@@"
	!tx "wrap..."
	!tx "@@@@"
	
	!byte $ff
*= $1000
	!bin "ZoolookTempoReduxAltDrumsNew.SID",,126

random
	lda #$00 ; generate random number from 0-255
    eor $dc04
	eor $dc05
	eor $dd04
	adc $dd05
	eor $dd06
	eor $dd07
	sta random+1
waste12cycles
	rts	

xpos	
	lda #$00
	tay
	sta d010val+1
-	jsr random
	and #%00000111
	cmp #05
	bcs -
	cmp #04
	bne +
	inc d010val+1
	tay
	lda #$00
+	tax
	beq +
	lda #$00
-	clc
	adc #56
	dex
	bne -
+	sta operandx+1
-	jsr random
	and #%00011111
	cmp #28
	bpl -
	asl; as we've got MC -> double pixel...
	cpy #4
	beq +
	clc
	adc #32
+	clc
operandx	
+	adc #$00
	tax; x-pos in x reg

ypos
	ldy #49
+	sty operandy+1
	jsr random
	lsr
	lsr
;	clc; no, carry leads to wanted possible extra +1 (63+3+1)
	adc operandy+1
	sta operandy+1
	jsr random
	lsr
	lsr
	lsr
	lsr
	lsr
	lsr
;	clc; no, carry leads to wanted possible extra +1 (63+3+1)
operandy	
	adc #$00	
	; accu = yposval -> sta vic+1
d010val
	ldy #$00
	rts
computed010	
	and #%00000111
	tax
	lda #%00000001; restore
	sta d010oraval+1
	lda #%11111110
	sta d010andval+1	
	tya
	beq ++
	cpx #$00
	beq +
-	rol d010oraval+1
	dex
	bne -
d010computingval1
+	lda overflowtab
d010oraval
	ora #%00000001
	jmp +++
++	cpx #$00
	beq +
-	rol d010andval+1
	dex
	bne -
d010computingval2
+	lda overflowtab
d010andval
	and #%11111110
+++	rts

pointertab
	!byte $28,$29,$29,$2a,$2a,$2a,$2a,$2b,$2b,$2b,$2b,$2b,$2c,$2c,$2c,$2c
	!byte $2c,$2c,$2c,$2c,$2c,$2b,$2b,$2b,$2b,$2b,$2a,$2a,$2a,$2a,$29,$29

; everything from $1757 upwards is unused	